Scala Compiler2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root

  The Scala compiler and reflection APIs.

  The Scala compiler and reflection APIs.

  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package tools
  Definition Classes
    scala
-  package nsc
  Definition Classes
    tools
-  package transform
  Definition Classes
    nsc
-  package patmat
  Definition Classes
    transform
-  trait Solving extends Logic

  Solve pattern matcher exhaustivity problem via DPLL.

  Solve pattern matcher exhaustivity problem via DPLL.

  Definition Classes
    patmat
-  trait CNF extends PropositionalLogic
  Definition Classes
    Solving
- AbsVar
- AlreadyInCNF
- AnalysisBudget
- And
- AtMostOne
- CnfBuilder
- Const
- Eq
- False
- Not
- Or
- Prop
- PropMap
- PropTraverser
- Solution
- Solvable
- Sym
- SymbolMapping
- TransformToCnf
- Tree
- True
- Type
- TypeConst
- TypeConstExtractor
- ValueConst
- ValueConstExtractor
- Var
- VarExtractor

c

scala.tools.nsc.transform.patmat.Solving.CNF

# TransformToCnf 

###

#### class TransformToCnf extends CnfBuilder

Plaisted transformation: used for conversion of a propositional formula into conjunctive normal form (CNF) (input format for SAT solver). A simple conversion into CNF via Shannon expansion would also be possible but it's worst-case complexity is exponential (in the number of variables) and thus even simple problems could become untractable. The Plaisted transformation results in an _equisatisfiable_ CNF-formula (it generates auxiliary variables) but runs with linear complexity. The common known Tseitin transformation uses bi-implication, whereas the Plaisted transformation uses implication only, thus the resulting CNF formula has (on average) only half of the clauses of a Tseitin transformation. The Plaisted transformation uses the polarities of sub-expressions to figure out which part of the bi-implication can be omitted. However, if all sub-expressions have positive polarity (e.g., after transformation into negation normal form) then the conversion is rather simple and the pseudo-normalization via NNF increases chances only one side of the bi-implication is needed.

Source
  Solving.scala

Linear Supertypes
CnfBuilder, AnyRef, Any
Type Hierarchy
 
Ordering

1. Alphabetic
2. By Inheritance

Inherited

1. TransformToCnf
2. CnfBuilder
3. AnyRef
4. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Instance Constructors

1.  new TransformToCnf(symbolMapping: SymbolMapping)

### Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from TransformToCnf to any2stringadd[TransformToCnf] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (TransformToCnf, B)
   Implicit
     This member is added by an implicit conversion from TransformToCnf to ArrowAssoc[TransformToCnf] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  def addClauseProcessed(clause: Clause): Unit
   Definition Classes
     CnfBuilder
7.  def apply(p: CNF.Prop): Solvable
8.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
9.  def buildCnf: Array[Clause]
   Definition Classes
     CnfBuilder
10.  def clone(): AnyRef
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
11.  def constFalse: Lit
    Definition Classes
      CnfBuilder
12.  lazy val constTrue: Lit
    Definition Classes
      CnfBuilder
13.  def convertSym(sym: CNF.Sym): Lit
14.  def ensuring(cond: (TransformToCnf) ⇒ Boolean, msg: ⇒ Any): TransformToCnf
    Implicit
      This member is added by an implicit conversion from TransformToCnf to Ensuring[TransformToCnf] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
15.  def ensuring(cond: (TransformToCnf) ⇒ Boolean): TransformToCnf
    Implicit
      This member is added by an implicit conversion from TransformToCnf to Ensuring[TransformToCnf] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
16.  def ensuring(cond: Boolean, msg: ⇒ Any): TransformToCnf
    Implicit
      This member is added by an implicit conversion from TransformToCnf to Ensuring[TransformToCnf] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
17.  def ensuring(cond: Boolean): TransformToCnf
    Implicit
      This member is added by an implicit conversion from TransformToCnf to Ensuring[TransformToCnf] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
18.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
19.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
20.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
21.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from TransformToCnf to StringFormat[TransformToCnf] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
22.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
23.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
24.  def isConst(l: Lit): Boolean
    Definition Classes
      CnfBuilder
25.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
26.  var literalCount: Int
    Definition Classes
      TransformToCnf → CnfBuilder
27.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
28.  def newLiteral(): Lit

    returns

      new Tseitin variable

    Definition Classes
      CnfBuilder
29.  final def notify(): Unit
    Definition Classes
      AnyRef
30.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
31.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
32.  def toString(): String
    Definition Classes
      AnyRef → Any
33.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
34.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
35.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
36.  def →[B](y: B): (TransformToCnf, B)
    Implicit
      This member is added by an implicit conversion from TransformToCnf to ArrowAssoc[TransformToCnf] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from CnfBuilder

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from TransformToCnf to any2stringadd[TransformToCnf]

### Inherited by implicit conversion StringFormat from TransformToCnf to StringFormat[TransformToCnf]

### Inherited by implicit conversion Ensuring from TransformToCnf to Ensuring[TransformToCnf]

### Inherited by implicit conversion ArrowAssoc from TransformToCnf to ArrowAssoc[TransformToCnf]

### Ungrouped